﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.ChartView;
using Telerik.Charting;

namespace sl_ChartView_582099
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();

            var chartSeriesLabelDef = new ChartSeriesLabelDefinition() { VerticalAlignment = System.Windows.VerticalAlignment.Center };
            var barStyle = new System.Windows.Style(typeof(Border));
            barStyle.Setters.Add(new Setter(Border.BorderThicknessProperty, new Thickness(1)));

            BarSeries ser = new BarSeries();
            ser.ValueBinding = new PropertyNameDataPointBinding("IRBDuration");
            ser.CategoryBinding = new PropertyNameDataPointBinding("EndYear");
            ser.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            ser.ShowLabels = true;
            ser.LabelDefinitions.Add(chartSeriesLabelDef);
            ser.DefaultVisualStyle = barStyle;

            BarSeries ser2 = new BarSeries();
            ser2.ValueBinding = new PropertyNameDataPointBinding("IRBDuration");
            ser2.CategoryBinding = new PropertyNameDataPointBinding("EndYear");
            ser2.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            ser2.ShowLabels = true;
            ser2.LabelDefinitions.Add(chartSeriesLabelDef);
            ser2.DefaultVisualStyle = barStyle;

            BarSeries ser3 = new BarSeries();
            ser3.ValueBinding = new PropertyNameDataPointBinding("IRBDuration");
            ser3.CategoryBinding = new PropertyNameDataPointBinding("EndYear");
            ser3.CombineMode = Telerik.Charting.ChartSeriesCombineMode.Stack;
            ser3.ShowLabels = true;
            ser3.LabelDefinitions.Add(chartSeriesLabelDef);
            ser3.DefaultVisualStyle = barStyle;

            chart.Series.Add(ser);
            chart.Series.Add(ser2);
            chart.Series.Add(ser3);
            ser.ItemsSource = this.GenerateItemsSource1();
            ser2.ItemsSource = this.GenerateItemsSource2();
            ser3.ItemsSource = this.GenerateItemsSource3();

            this.InsertSumBarSeries(new BarSeries[] { ser, ser2, ser3, });

        }

        private void InsertSumBarSeries(BarSeries[] barSeries)
        {
            Dictionary<string, double> endYearToSumDuration = new Dictionary<string, double>();

            foreach (var series in barSeries)
            {
                foreach (PlotInfo plotInfo in series.ItemsSource)
                {
                    if (!endYearToSumDuration.ContainsKey(plotInfo.EndYear))
                        endYearToSumDuration[plotInfo.EndYear] = 0;

                    endYearToSumDuration[plotInfo.EndYear] += plotInfo.IRBDuration;
                }
            }

            BarSeries sumSeries = (BarSeries)this.chart.Series[0];
            foreach (var pair in endYearToSumDuration)
            {
                sumSeries.DataPoints.Add(new CategoricalDataPoint() { Category = pair.Key, Value = pair.Value });
            }
        }

        private System.Collections.IEnumerable GenerateItemsSource1()
        {
            return new List<PlotInfo>() 
            { 
                new PlotInfo { EndYear = "1", IRBDuration = 123, },
                new PlotInfo { EndYear = "2", IRBDuration = 113, },
                new PlotInfo { EndYear = "3", IRBDuration = 143, },
                //new PlotInfo { EndYear = "3", IRBDuration = 153, },
                new PlotInfo { EndYear = "4", IRBDuration = 129, },
            };        
        }

        private System.Collections.IEnumerable GenerateItemsSource2()
        {
            return new List<PlotInfo>() 
            { 
                new PlotInfo { EndYear = "1", IRBDuration = 134, },
                new PlotInfo { EndYear = "2", IRBDuration = 124, },
                new PlotInfo { EndYear = "3", IRBDuration = 154, },
                //new PlotInfo { EndYear = "3", IRBDuration = 153, },
                new PlotInfo { EndYear = "4", IRBDuration = 138, },
            };
        }

        private System.Collections.IEnumerable GenerateItemsSource3()
        {
            return new List<PlotInfo>() 
            { 
                new PlotInfo { EndYear = "1", IRBDuration = 144, },
                new PlotInfo { EndYear = "2", IRBDuration = 144, },
                new PlotInfo { EndYear = "3", IRBDuration = 133, },
                //new PlotInfo { EndYear = "3", IRBDuration = 153, },
                new PlotInfo { EndYear = "4", IRBDuration = 122, },
            };
        }
    }

    public class PlotInfo
    {
        public string EndYear { get; set; }
        public double IRBDuration { get; set; }
    }
}
